/********************************************************/
/*                                                      */
/*     89c2051/8031 mikrogep program  			*/
/*                                                      */
/*      2000.AUGUSZTUS                                  */
/*      Ksztette: Torkos Csaba			*/
/********************************************************/

/*      Szabvanyos definiciok

rbank0          =       $0
rbank1          =       $8
rbank2          =       $10
rbank3          =       $18

REG0            =       $0
REG1            =       $1
REG2            =       $2
REG3            =       $3
REG4            =       $4
REG5            =       $5
REG6            =       $6
REG7            =       $7

REG10           =       $8
REG11           =       $9
REG12           =       $A
REG13           =       $B
REG14           =       $C
REG15           =       $D
REG16           =       $E
REG17           =       $F

REG20           =       $10
REG21           =       $11
REG22           =       $12
REG23           =       $13
REG24           =       $14
REG25           =       $15     /* Flagek-nek hasznalt
REG26           =       $16
REG27           =       $17

REG30           =       $18
REG31           =       $19
REG32           =       $1A
REG33           =       $1B
REG34           =       $1C
REG35           =       $1D
REG36           =       $1E
REG37           =       $1F

P0              =       $80
SP              =       $81
DPL             =       $82
DPH             =       $83
PCON            =       $87
TCON            =       $88
TMOD            =       $89
TL0             =       $8a
TL1             =       $8b
TH0             =       $8c
TH1             =       $8d

P1              =       $90
SCON            =       $98
SBUF            =       $99
P2              =       $a0
IEC             =       $a8
P3              =       $b0
IPC             =       $b8
PSW             =       $d0
ACC             =       $e0
B               =       $f0

/********************************************************/
/*      Szabvanyos bitdefiniciok
/********  P1 BITS ********

P10             =       $90
P11             =       $91
P12             =       $92
P13             =       $93
P14             =       $94
P15             =       $95
P16             =       $96
P17             =       $97

/********  P3 BITS ********

P30             =       $b0
P31             =       $b1
P32             =       $b2
P33             =       $b3
P34             =       $b4
P35             =       $b5
P36             =       $b6
P37             =       $b7

RXD             =       P30
TXD             =       P31
INT0            =       P32
INT1            =       P33
T0              =       P34
T1              =       P35
WR              =       P36
RD              =       P37

/******** TCON BITS *******

IT0             =       $88
IE0             =       $89
IT1             =       $8a
IE1             =       $8b
TR0             =       $8c
TF0             =       $8d
TR1             =       $8e
TF1             =       $8f

/******** SCON BITS *******

RI              =       $98     /* veteli megszakitas flag
TI              =       $99
RB8             =       $9a
TB8             =       $9b
REN             =       $9c
SM2             =       $9d
SM1             =       $9e
SM0             =       $9f

/********  IE  BITS *******

EX0             =       $a8
ET0             =       $a9
EX1             =       $aa
ET1             =       $ab
ES              =       $ac
ET2             =       $ad
EA              =       $af

/********  IP  BITS *******

PX0             =       $b8
PT0             =       $b9
PX1             =       $ba
PT1             =       $bb
PS              =       $bc
PT2             =       $bd

/******** PSW  BITS *******

P               =       $d0     /* paritas
OV              =       $d2     /* overflow
RS0             =       $d3     /* R bank sel
RS1             =       $d4     /* R bank sel
F0              =       $d5     /* user flag
AC              =       $d6     /* aux carry
CY              =       $d7     /* carry

/******** Az Accumulator es a B regiszter bitjei  *******

ACC0            =       $e0
ACC1            =       $e1
ACC2            =       $e2
ACC3            =       $e3
ACC4            =       $e4
ACC5            =       $e5
ACC6            =       $e6
ACC7            =       $e7

B0              =       $f0
B1              =       $f1
B2              =       $f2
B3              =       $f3
B4              =       $f4
B5              =       $f5
B6              =       $f6
B7              =       $f7


/********************************************************/
/*      RAM terulet ($00-$7f)

/*      $00-$1f         regiszterek
/*      $20-$2f         bitenkent cimezheto USER terulet
/*      $30-$5f         renszervltozk,puffer terulet
/*      $60-$7f         stack (32byte)

/********************************************************/
/*	Sajat kituntetett ertekek
/*      Valtozok  es konstansok


/*	6Mhz/12/250 oszto1=256-250 (0.5 ms)
/*	6Mhz/12/250/200 oszto2=200 (0.1 s)
OSZTO1		=	  6
OSZTO2		=	200

STACK           =       $60

MP		=       $30
PERC		=       $31
ORA		=       $32
BCD01		=       $36
BCD23		=       $37
BISM		=       $38

SEGED		=	$39

/********************************************************/
/*      Felhasznalt bitek USER teruletrol

BILLTESZT	=	$01
BFLAG1		=	$02
BFLAG2		=	$03
FLAG500ms	=	$04

MODE1		=       $08
MODE2		=       $09
MODE3		=       $0A
MODE4		=       $0B
MODE		=	$21

DIG0		=       $10
DIG1		=       $11
DIG2		=       $12
DIG3		=       $13
kindex		=       $22     /* A kijelzshez hasznlt $10-71 bitek

/********************************************************/
/*      Rendszervaltozok

/********************************************************/
/*              Vektorok

RESET           org $0000       /* reset
                LJMP    start

                org $0003       /* ext.int.0
                ljmp extint0

                org $000b       /* timer 0
                ljmp timer0int

                org $0013       /* ext.int.1
                ljmp extint1

                org $001b       /* timer 1
                ljmp timer1int

                org $0023       /* soros port
                ljmp sorosint


/********************************************************/
/*      Konfiguracios adatok

/********************************************************/
/*      Programterulet kezdete
/********************************************************/
/*      Indito programresz

start		MOV     PSW,#rbank0     /* R.bank 0
		MOV     SP,#STACK       /* Stack beallitas
		MOV	P1,#$FF

/*      A bels RAM trlse

                MOV     R0,#0		/* User RAM terulet torlese
                CLR     A
start1          MOV     @R0,A
                INC     R0
                CJNE    R0,#129,start1
                MOV     R0,#00

/*      Kezdoertekek
		MOV     REG35,#10
		MOV     REG36,#10
		MOV     REG37,#OSZTO2

		MOV     ORA,#$0
		MOV     PERC,#$0
		MOV     MODE,#1

/*      Timer inicializalas
/*      timer0: mode 2  TH0: idozites
/*      timer1: mode 1  TH1,TL1: 16-bites esemenyszamlalo
                MOV     TMOD,#$52
/*      6Mhz/12/250
                MOV     TH0,#OSZTO1  /* 0.1 ms -> 6MHz

		MOV	TH1,#0
		MOV	TL1,#0

/*      Interruptok
                MOV     IEC,#0
                SETB    ET0     /* timer0
                SETB    PT0     /* magas prioritas
/*              SETB    ES      /* soros port
                CLR     EX1     /* kulso int1 tiltva
/*              SETB    IT1     /* elre aktiv
                CLR     EX0     /* kulso int0 tiltva
/*              SETB    IT0     /* elre aktiv
                SETB    TR0	/* timer0 run
/*                SETB    TR1	/* timer1 run
                SETB    EA      /* altalanos eng.

		SETB    INT0
		SETB    INT1
		SETB    T0
		SETB    T1

		LJMP    FO

/********************************************************/
/*      Megszakitasok
extint0         RETI
extint1         RETI
sorosint        RETI

/********************************************************/
/*      0 timer interrupt
/*      Prioritasban magas szint
/*      Autoreload uzemmod
/*      Ismetlesi ido: 0,5ms
/*      3.regiszterbankot hasznalja (ezt hasznalja meg a soros INT is)
/*      R0:     Segedregiszter (soros INT)
/*      R1:     Darab szamlalo a VETEL-hez
/*      R2:     LCD hasznalja
/*      R3:     LCD hasznalja
/*      R4:
/*      R5:     altalanos csokkento reg. (0,1ms)
/*      R6:     csokkento regiszter 1 s
/*      R7:     csokkento regiszter 0.1 s

timer0int	PUSH    PSW
		PUSH    ACC
		PUSH    DPH
		PUSH    DPL
		MOV	PSW,#rbank3
		
		LCALL   KIJELZES
		
		DJNZ    R7,timer0v      /* 200ms
		MOV     R7,#OSZTO2

		cjne	R6,#5,sec
		CPL	T0
		setb 	FLAG500ms
				
sec		DJNZ    R6,timer0v	/* 500ms letelt
		MOV     R6,#10		
		CPL	T0
		setb 	FLAG500ms
				
		MOV	A,MP
		ADD	A,#01
		DA	A
		MOV	MP,A
		ADD	A,#$A0
		JNC	timer0v
/*	PERC:
		MOV	MP,#00
		MOV	A,PERC
		ADD	A,#01
		DA	A
		MOV	PERC,A
		ADD	A,#$A0
		JNC	timer0v
/*	ORA :
		MOV	PERC,#00
		MOV	A,ORA
		ADD	A,#01
		DA	A
		MOV	ORA,A
		ADD	A,#$DC
		JNC	timer0v

		MOV	ORA,#00
		
timer0v         POP     DPL
                POP     DPH
                POP     ACC
                POP     PSW
                RETI

/********************************************************/
/*      1 timer interrupt
/*      16-bites szamlalo uzemmod
/*      2.regiszterbankot hasznalja
/*      R0:
/*      R1:
/*      R2:
/*      R3:
/*      R4:
/*      R5:
/*      R6:
/*      R7:

timer1int	PUSH    PSW
		PUSH    ACC
		PUSH    DPH
		PUSH    DPL
/*		MOV	PSW,#rbank2

timer1v         POP     DPL
                POP     DPH
                POP     ACC
                POP     PSW
                RETI

/********************************************************/
/*  Kijelzo rutin es a Billentyuk kezelese, a timer interrupt hivja
/*  A BCD01-BCD23 regiszter tartalmt viszi ki digitenknt
/*  a 4 szegmenses LED kijelzre.

kijelzes	MOV	A,BISM
		MOV     A,kindex
                JNZ     kij0
                MOV     kindex,#$01
kij0            JNB     DIG0,kij1
                MOV     A,BCD01
                SWAP    A
                ANL     A,#$F0	/*0F
                ORL     A,#$07	/*70
                MOV     B,A
                LCALL	kij100	/*SJMP
		RET
kij1            JNB     DIG1,kij2
                MOV     A,BCD01
                ANL     A,#$F0	/*0F
                ORL     A,#$0B	/*B0
                MOV     B,A
		LCALL	kij100
		RET
kij2            JNB     DIG2,kij3
                MOV     A,BCD23
                SWAP    A
                ANL     A,#$F0	/*0F
                ORL     A,#$0D	/*D0
                MOV     B,A
		LCALL	kij100
		RET
kij3            JNB     DIG3,kijv
                MOV     A,BCD23
                ANL     A,#$F0	/*0F
		JNZ	kijx
		MOV	A,#$F0	/*Nullkioltasnak
kijx		ORL     A,#$0E	/*E0
                MOV     B,A
		LCALL	kij100
kijv		RET

kij100          MOV     A,B
		swap	A
		MOV	P1,A
                mov     A,kindex
                CLR     C
                RLC     A
                anl     A,#$0F
                mov     kindex,A
                ret

/********************************************************/
/*      Fo mukodesi ciklus
/*
/*      0.regiszterbankot hasznalja
/*      R0:
/*      R1:
/*      R2:
/*      R3:
/*      R4:
/*      R5:
/*      R6:
/*      R7:

/*      FO CIKLUS
/*		ORG	$04A0

FO		MOV     PSW,#rbank0     /* R.bank 0
		
		JB      INT0,noset
		jb	BFLAG1,m1
		lcall	setting
		sjmp	m1
noset		clr	BFLAG1
m1		jnb	MODE1,m2
		MOV     BCD01,PERC
                MOV     BCD23,ORA
		sjmp	FO
		
m2		jnb	MODE2,m3
		jnb	T0,soteto
		MOV     BCD23,ORA
		sjmp	m2x		
soteto		MOV     BCD23,#$ff
m2x		MOV     BCD01,PERC
		jnb	INT1,orall
		clr	BFLAG2
		ljmp	FO
		
orall		jb	BFLAG2,FO
		MOV	A,ORA
		ADD	A,#01
		DA	A
		MOV	ORA,A
		CJNE	A,#$24,orav
                MOV	ORA,#0
orav		setb	BFLAG2		
	        SJMP	FO

m3		jnb	MODE3,m4
		jnb	T0,sotetp
		MOV     BCD01,PERC
		sjmp	m3x		
sotetp		MOV     BCD01,#$ff
m3x		MOV     BCD23,ORA
		jnb	INT1,percall
		clr	BFLAG2
		ljmp	FO
		
percall		jb	BFLAG2,FO		
		MOV	A,PERC
		ADD	A,#01
		DA	A
		MOV	PERC,A
		CJNE	A,#$60,percv
                MOV	PERC,#0
		
percv		setb	BFLAG2				
		LJMP    FO

m4		jnb	MODE4,FO

		MOV     BCD01,MP
		MOV     BCD23,#$ff
		jb	INT1,back		
		mov	MP,#0
		
back		LJMP    FO

setting		mov	A,MODE
		RL	A
		cjne	A,#$10,nomore
		MOV	A,#$01
nomore		mov	MODE,A
		setb	BFLAG1
		ret

/********************************************************
/* BCD -> binaris 1byte
/* A: adat

bcdbin  push ACC
        anl A,#$f0
        swap A          /* A-ban a tizesek
        JZ bcd0
        mov R0,A
        CLR A
bcdbin1 add A,#10
        djnz R0,bcdbin1
        MOV R0,A
bcd0    pop ACC
        anl A,#$0f
        add A,R0
        ret

